Index: doc/bsp_howto/discrete.t
===================================================================
--- doc/bsp_howto/discrete.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/discrete.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -9,4 +9,175 @@
 @chapter Discrete Driver
 
-XXX FILL ME IN
+The Discrete driver is responsible for providing an
+interface to Discrete Input/Outputs.  The capabilities provided
+by this class of device driver are:
 
+@itemize @bullet
+@item Initialize a Discrete I/O Board
+@item Open a Particular Discrete Bitfield
+@item Close a Particular Discrete Bitfield
+@item Read from a Particular Discrete Bitfield
+@item Write to a Particular Discrete Bitfield
+@item Reset DACs
+@item Reinitialize DACS
+@end itemize
+
+Most discrete I/O devices are found on I/O cards that support many
+bits of discrete I/O on a single card.  This driver model is centered
+on the notion of reading bitfields from the card.
+
+There are currently no discrete I/O device drivers included in the 
+RTEMS source tree.  The information provided in this chapter
+is based on drivers developed by OAR Corporation personnel
+for applications using RTEMS.   It is hoped that this
+driver model information can form the basis for a standard
+discrete I/O driver model that can be supported in future RTEMS
+distribution.
+
+@section Major and Minor Numbers
+
+The @b{major} number of a device driver is its index in the 
+RTEMS Device Address Table.
+
+A @b{minor} number is associated with each device instance
+managed by a particular device driver.  An RTEMS minor number 
+is an @code{unsigned32} entity.  Convention calls for
+dividing the bits in the minor number down into categories
+that specify a particular bitfield.  This results in categories
+like the following:
+
+@itemize @bullet
+
+@item @b{board} - indicates the board a particular bitfield is located on
+@item @b{word} - indicates the particular word of discrete bits the
+bitfield is located within
+@item @b{start} - indicates the starting bit of the bitfield
+@item @b{width} - indicates the width of the bitfield
+
+@end itemize
+
+From the above, it should be clear that a single device driver
+can support multiple copies of the same board in a single system.
+The minor number is used to distinguish the devices.
+
+By providing a way to easily access a particular bitfield from
+the device driver, the application is insulated with knowing how
+to mask fields in and out of a discrete I/O.
+
+@section Discrete I/O Driver Configuration
+
+There is not a standard discrete I/O driver configuration table but some
+fields are common across different drivers.  The discrete I/O driver
+configuration table is typically an array of structures with each
+structure containing the information for a particular board.
+The following is a list of the type of information normally required
+to configure an discrete I/O board:
+
+@table @b
+@item board_offset
+is the base address of a board.
+
+@item relay_initial_values
+is an array of the values that should be written to each output
+word on the board during initialization.  This allows the driver
+to start with the board's output  in a known state.
+
+@end table
+
+@section Initialize a Discrete I/O Board
+
+At system initialization, the discrete I/O driver's initialization entry point
+will be invoked.  As part of initialization, the driver will perform
+whatever board initializatin is required and then set all
+outputs to their configured initial state.
+
+The discrete I/O driver may register a device name for bitfields of 
+particular interest to the system.  Normally this will be restricted
+to the names of each word and, if the driver supports it, an "all words".
+
+@section Open a Particular Discrete Bitfield
+
+This is the driver open call.  Usually this call does nothing other than
+validate the minor number.  
+
+With some drivers, it may be necessary to allocate memory when a particular
+device is opened.  If that is the case, then this is often the place
+to do this operation.
+
+@section Close a Particular Discrete Bitfield
+
+This is the driver close call.  Usually this call does nothing.
+
+With some drivers, it may be necessary to allocate memory when a particular
+device is opened.  If that is the case, then this is the place
+where that memory should be deallocated.
+
+@section Read from a Particular Discrete Bitfield
+
+This corresponds to the driver read call.  After validating the minor
+number and arguments, this call reads the indicated bitfield.  A
+discrete I/O devices may have to store the last value written to
+a discrete output.  If the bitfield is output only, saving the last
+written value gives the appearance that it can be read from also.  
+If the bitfield is input, then it is sampled.
+
+@b{NOTE:} Many discrete inputs have a tendency to bounce.  The application
+may have to take account for bounces.
+
+The value returned is an @code{unsigned32} number 
+representing the bitfield read.  This value is stored in the
+@code{argument_block} passed in to the call.
+
+@b{NOTE:} Some discrete I/O drivers have a special minor number
+used to access all discrete I/O bits on the board.  If this special
+minor is used, then the area pointed to by @code{argument_block} must
+be the correct size.
+
+@section Write to a Particular Discrete Bitfield
+
+This corresponds to the driver write call.  After validating the minor
+number and arguments, this call writes the indicated device.  If the
+specified device is an ADC, then an error is usually returned.  
+
+The value written is an @code{unsigned32} number 
+representing the value to be written to the specified
+bitfield.  This value is stored in the
+@code{argument_block} passed in to the call.
+
+@b{NOTE:} Some discrete I/O drivers have a special minor number
+used to access all discrete I/O bits on the board.  If this special
+minor is used, then the area pointed to by @code{argument_block} must
+be the correct size.
+
+@section Disable Discrete Outputs
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+the discrete outputs are disabled.
+
+@b{NOTE:} It may not be possible to disable/enable discrete output on all 
+discrete I/O boards.
+
+@section Enable Discrete Outputs
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+the discrete outputs are enabled.
+
+@b{NOTE:} It may not be possible to disable/enable discrete output on all
+discrete I/O boards.
+
+@section Reinitialize Outputs
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+the discrete outputs are rewritten with the configured initial
+output values.
+
+@section Get Last Written Values
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+the last value written to the specified output word along with
+a timestamp of when the last write was performed.
+
Index: doc/bsp_howto/init.t
===================================================================
--- doc/bsp_howto/init.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/init.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -22,9 +22,11 @@
 initialization code.  Like most BSPs, the initialization for this 
 BSP is divided into two subdirectories under the BSP source directory.
-The gen68340 BSP source code in the following directory:
-
-@example
-c/src/lib/libbsp/m68k/gen68340: 
-@end example
+The gen68340 BSP source code is in the following directory:
+
+@example
+c/src/lib/libbsp/m68k/gen68340
+@end example
+
+The following source code files are in this subdirectory.
 
 @itemize @bullet
@@ -46,4 +48,24 @@
 contains initialization for a 68349 based board as well.
 
+@section Required Global Variables
+
+Although not strictly part of initialization, there are a few global
+variables assumed to exist by many support components.  These 
+global variables are usually declared in the file @code{startup/bspstart.c}
+that provides most of the BSP specific initialization.  The following is
+a list of these global variables:
+
+@itemize @bullet
+@item @code{BSP_Configuration} is the BSP's writable copy of the RTEMS
+Configuration Table.
+
+@item @code{Cpu_table} is the RTEMS CPU Dependent Information Table.
+
+@item @code{bsp_isr_level} is the interrupt level that is set at
+system startup.  It will be restored when the executive returns
+control to the BSP.
+
+@end itemize
+
 @section Board Initialization
 
@@ -77,5 +99,5 @@
 
 The @code{boot_card()} is the first C code invoked.  Most of the BSPs
-use the sams shared version of @code{boot_card()} which is located in
+use the same shared version of @code{boot_card()} which is located in
 the following file:
 
@@ -129,6 +151,9 @@
 This routine is also responsible for overriding the default settings
 in the CPU Configuration Table and setting port specific entries
-in this table.  This routine will typically install routines
-for one or more of the following initialization hooks:
+in this table.  This may include increasing the maximum number
+of some types of RTEMS system objects to reflect the needs of 
+the BSP and the base set of device drivers. This routine will
+typically also install routines for one or more of the following
+initialization hooks:
 
 @itemize @bullet
@@ -173,5 +198,5 @@
 
 In addition to the implicit invocation of @code{__main}, this 
-routine performs some explitit initialization.  This routine 
+routine performs some explicit initialization.  This routine 
 sets the variable @code{rtems_progname} and initiates 
 multitasking via a call to the RTEMS directive
@@ -180,9 +205,13 @@
 RTEMS directive @code{rtems_shutdown_executive} is invoked.
 
+The RTEMS initialization procedure is described in the @b{Initialization
+Manager} chapter of the @b{RTEMS Application C User's Guide}.
+Please refer to that manual for more information.
+
 @subsection RTEMS Pretasking Callback
 
 The @code{pretasking_hook} entry in the RTEMS CPU Configuration
 Table may be the address of a user provided routine that is
-invoked once RTEMS initialization is complete but before interrupts
+invoked once RTEMS API initialization is complete but before interrupts
 and tasking are enabled.  No tasks -- not even the IDLE task -- have
 been created when this hook is invoked.  The pretasking hook is optional.
@@ -198,17 +227,28 @@
 The @code{bsp_pretasking_hook()} routine is the appropriate place to
 initialize any support components which depend on the RTEMS APIs.
-Most BSPs initialize the RTEMS C Library support in their
+Most BSPs set the debug level for the system and initialize the
+RTEMS C Library support in their
 implementation of @code{bsp_pretasking_hook()}.  This initialization
-includes the application heap as well as the reentrancy support
-for the C Library.
+includes the application heap used by the @code{malloc} family
+of routines as well as the reentrancy support for the C Library.
+
+The routine @code{bsp_libc_init} routine invoked from the
+@code{bsp_pretasking_hook()} routine is passed the starting
+address, length, and growth amount passed to @code{sbrk}.  
+This "sbrk amount" is only used if the heap runs out of
+memory.  In this case, the RTEMS malloc implementation will
+invoked @code{sbrk} to obtain more memory.  See
+@ref{Miscellaneous Support Files sbrk() Implementation} for more details.
 
 @subsection RTEMS Predriver Callback
 
-XXX is the address of the user provided
-routine which is invoked with tasking enabled immediately before
-the MPCI and device drivers are initialized. RTEMS
-initialization is complete, interrupts and tasking are enabled,
-but no device drivers are initialized.  This field may be NULL to
-indicate that the hook is not utilized.
+The @code{predriver_hook} entry in the RTEMS CPU Configuration
+Table may be the address of a user provided routine that is
+is invoked immediately before the the device drivers and MPCI
+are initialized. RTEMS
+initialization is complete but interrupts and tasking are disabled.
+This field may be NULL to indicate that the hook is not utilized.
+
+Most BSPs do not use this callback.
 
 @subsection Device Driver Initialization
@@ -216,29 +256,88 @@
 At this point in the initialization sequence, the initialization 
 routines for all of the device drivers specified in the Device
-Driver Table are invoked.
+Driver Table are invoked.  The initialization routines are invoked
+in the order they appear in the Device Driver Table.
+
+The Driver Address Table is part of the RTEMS Configuration Table. It
+defines device drivers entry points (initialization, open, close, read,
+write, and control). For more information about this table, please
+refer to the @b{Configuring a System} chapter in the
+@b{RTEMS Application C User's Guide}.
+
+The RTEMS initialization procedure calls the initialization function for
+every driver defined in the RTEMS Configuration Table (this allows
+one to include only the drivers needed by the application). 
+
+All these primitives have a major and a minor number as arguments: 
+
+@itemize @bullet
+
+@item the major number refers to the driver type,
+
+@item the minor number is used to control two peripherals with the same
+driver (for instance, we define only one major number for the serial
+driver, but two minor numbers for channel A and B if there are two
+channels in the UART). 
+
+@end itemize
 
 @subsection RTEMS Postdriver Callback
 
-XXX is the address of the user provided
-routine which is invoked with tasking enabled immediately after
-the MPCI and device drivers are initialized. RTEMS
-initialization is complete, interrupts and tasking are enabled,
-and the device drivers are initialized.  This field may be NULL
-to indicate that the hook is not utilized.
-
-
-@section The Interrupts Vector Table
-
-
-
-After the entry label starts a code section in which some room is
-allocated for the table of interrupts vectors. They are assigned to the
-address of the __uhoh label. 
-
-At __uhoh label you can find the default interrupt handler routine. This
-routine is only called when an unexpected interrupts is raised. You can
-add your own routine there (in that case there's a call to a routine -
-$BSP_ROOT/startup/dumpanic.c - that pri nts which address caused the
-interrupt and the contents of the registers, stack...), but this should
+The @code{postdriver_hook} entry in the RTEMS CPU Configuration
+Table may be the address of a user provided routine that is
+invoked immediately after the the device drivers and MPCI are initialized.
+Interrupts and tasking are disabled.  The postdriver hook is optional.
+
+Although optional, most of the RTEMS BSPs provide a postdriver hook
+callback.  This routine is usually called @code{bsp_postdriver_hook}
+and is found in the file:
+
+@example
+c/src/lib/libbsp/CPU/BSP/startup/bsppost.c
+@end example
+
+The @code{bsp_postdriver_hook()} routine is the appropriate place to
+perform initialization that must be performed before the first task 
+executes but requires that a device driver be initialized.  The 
+shared implementation of the postdriver hook opens the default 
+standard in, out, and error files and associates them with 
+@code{/dev/console}.
+
+@section The Interrupt Vector Table
+
+The Interrupt Vector Table is called different things on different
+processor families but the basic functionality is the same.  Each
+entry in the Table corresponds to the handler routine for a particular
+interrupt source.  When an interrupt from that source occurs, the 
+specified handler routine is invoked.  Some context information is
+saved by the processor automatically when this happens.  RTEMS saves
+enough context information so that an interrupt service routine
+can be implemented in a high level language.
+
+On some processors, the Interrupt Vector Table is at a fixed address.  If
+this address is in RAM, then usually the BSP only has to initialize
+it to contain pointers to default handlers.  If the table is in ROM,
+then the application developer will have to take special steps to
+fill in the table.
+
+If the base address of the Interrupt Vector Table can be dynamically 
+changed to an arbitrary address, then the RTEMS port to that processor
+family will usually allocate its own table and install it.  For example,
+on some members of the Motorola MC68xxx family, the Vector Base Register
+(@code{vbr}) contains this base address.  
+
+@subsection Interrupt Vector Table on the gen68340 BSP
+
+The gen68340 BSP provides a default Interrupt Vector Table in the
+file @code{$BSP_ROOT/start340/start340.s}.  After the @code{entry}
+label is the definition of space reserved for the table of
+interrupts vectors.  This space is assigned the symbolic name
+of @code{__uhoh} in the @code{gen68340} BSP.
+
+At @code{__uhoh} label is the default interrupt handler routine. This
+routine is only called when an unexpected interrupts is raised.  One can
+add their own routine there (in that case there's a call to a routine -
+$BSP_ROOT/startup/dumpanic.c - that prints which address caused the
+interrupt and the contents of the registers, stack, etc.), but this should
 not return. 
 
@@ -246,26 +345,42 @@
 
 When the microprocessor accesses a memory area, address decoding is
-handled by an address decoder (!), so that the microprocessor knows which
-memory chip to access. 
-
-Figure 4 : address decoding
-
-You have to program your Chip Select registers in order that they match
-the linkcmds settings. In this BSP ROM and RAM addresses can be found in
-both the linkcmds and initialization code, but this is not a great way to
-do, better use some shared variables . 
-
-@section Integrated processor registers initialization
-
-There are always some specific integrated processor registers
-initialization to do. Integrated processors' user manuals often detail
-them. 
-
-@section Data section recopy
+handled by an address decoder, so that the microprocessor knows which
+memory chip(s) to access.   The following figure illustrates this:
+
+@example
+@group
+                     +-------------------+
+         ------------|                   |
+         ------------|                   |------------
+         ------------|      Address      |------------
+         ------------|      Decoder      |------------
+         ------------|                   |------------
+         ------------|                   |
+                     +-------------------+
+           CPU Bus                           Chip Select
+@end group
+@end example
+
+
+The Chip Select registers must be programmed such that they match
+the @code{linkcmds} settings. In the gen68340 BSP, ROM and RAM
+addresses can be found in both the @code{linkcmds} and initialization
+code, but this is not a great way to do this.  It is better to
+define addresses in the linker script.
+
+@section Integrated Processor Registers Initialization
+
+The CPUs used in many embedded systems are highly complex devices
+with multiple peripherals on the CPU itself.  For these devices,
+there are always some specific integrated processor registers
+that must be initialized.  Refer to the processors' manuals for
+details on these registers and be VERY careful programming them.
+
+@section Data Section Recopy
 
 The next initialization part can be found in
-$BSP340_ROOT/start340/init68340.c. First the Interrupt Vector Table is
-copied into RAM, then the data section recopy is initiated
-(_CopyDataClearBSSAndStart in $BSP340_ROOT/start340/startfor340only.s). 
+@code{$BSP340_ROOT/start340/init68340.c}. First the Interrupt
+Vector Table is copied into RAM, then the data section recopy is initiated
+(_CopyDataClearBSSAndStart in @code{$BSP340_ROOT/start340/startfor340only.s}). 
 
 This code performs the following actions:
@@ -274,11 +389,10 @@
 
 @item copies the .data section from ROM to its location reserved in RAM
-(see 5.2 for more details about this copy),
-
-@item clear .bss section (all the non-initialized data will take value 0). 
-
-@end itemize
-
-Then control is passed to the RTEMS-specific initialization code. 
+(see @ref{Linker Script Initialized Data} for more details about this copy),
+
+@item clear @code{.bss} section (all the non-initialized
+data will take value 0). 
+
+@end itemize
 
 @section RTEMS-Specific Initialization
@@ -291,74 +405,19 @@
 structures. 
 
-The RTEMS configuration table is application dependant, which means that
-one has to provide one per application. It's usually an header file
-included in the main module of the application. 
-
-The BSP_Configuration label points on this table. 
-
-For more information on the RTEMS configuration table, refer to C user's
-guide, chapter 23 <insert a link here>. 
-
-@section RTEMS initialization procedure
-
-The RTEMS initialization procedure is described in the 3rd chapter of the
-C user's manual <insert a link here>. Please read it carefully. 
-
-There are a few BSP specific functions called from the initialization
-manager. They can be found in the startup directory of the BSP. 
-
-@table @b
-
-@item bspstart.c
-
-It starts the application.  It includes application, board, and monitor
-specific initialization and configuration. 
-
-@item bspstart.c
-
-@table @b
-@item bsp_pretasking_hook
-
-It starts libc support (needed to allocate some memory using C primitive
-malloc for example). Heap size must be passed in argument, this is the one
-which is defined in the linkcmds (cf. 5.) 
-
-
-@end table
-
-@item bspclean.c
-
-@table @b
-
-@item bsp_cleanup
-
-Return control to the monitor. 
-
-@end table
-
-@end table
-
-@section Drivers initialization
-
-The Driver Address Table is part of the RTEMS configuration table. It
-defines RTEMS drivers entry points (initialization, open, close, read,
-write, and control). For more information about this table, check C User's
-manual chapter 21 section 6 <insert a l ink here>. 
-
-The RTEMS initialization procedure calls the initialization function for
-every driver defined in the RTEMS Configuration Table (this permits to add
-only the drivers needed by the application). 
-
-All these primitives have a major and a minor number as arguments: 
-
-@itemize @bullet
-
-@item the major number refers to the driver type,
-
-@item the minor number is used to control two peripherals with the same
-driver (for instance, we define only one major number for the serial
-driver, but two minor numbers for channel A and B if there are two
-channels in the UART). 
-
-@end itemize
-
+The RTEMS configuration table is application dependent, which means that
+one has to provide one per application. It is usually defined
+by defining macros and including the header file @code{<confdefs.h>}.
+In simple applications such as the tests provided with RTEMS, it is
+commonly found in the main module of the application.  For more complex
+applications, it may be in a file by itself.
+
+The header file @code{<confdefs.h>} defines a constant table named
+@code{Configuration}.  It is common practice for the BSP to copy 
+this table into a modifiable copy named @code{BSP_Configuration}.
+This copy of the table is modified to define the base address of the
+RTEMS Executive Workspace as well as to reflect any BSP and
+device driver requirements not automatically handled by the application.
+
+For more information on the RTEMS Configuration Table, refer to the
+@b{RTEMS Application C User's Guide}.
+
